<?php

/**
 * CPB Add-on Product
 * @version 3.3.0
 */

// Exit if accessed directly
if (! defined('ABSPATH')) {
    exit;
}
//When the product is in stock display the quantity field
//Include the class for the various conditions like sold individually, backorders.
global $woocommerce, $post;

$allowBackOrder = '';
$disableQty = '';
$bundled_item_id = $item_data['product_type'] == "variation" ? $item_data['variation_id'] : $item_data['product_id'];
$parent_id = $item_data['product_id'];
$bundled_product = wc_get_product($bundled_item_id);
$quantity_min = 0;
$quantity_max = get_post_meta($bundled_item_id, '_stock', true);
$managing_stock = get_post_meta($bundled_item_id, '_manage_stock', true);
$qty_class = "quantity buttons_added";
if ($item_data['product_type'] == "variation" && $managing_stock == "no") {
    $parent_id = $item_data['product_id'];
    $quantity_max = get_post_meta($item_data['product_id'], '_stock', true);
    $qty_class .= " parent_stock";
}
if (!$bundled_product->is_sold_individually() || $quantity_min > 1) {
    if ($quantity_min == $quantity_max) {
        if ($quantity_min == 0) {
            $qty_class .= " qty_none";
        } else {
            $qty_class .= "";
            $disableQty = "disabled";
        }
    }
    if ($bundled_product->backorders_allowed()) {
        $qty_class .= " buttons_added";
        $allowBackOrder = 'yes';
    } else {
        $qty_class .= " buttons_added";
        $allowBackOrder = 'no';
    }
}
?>
<div class='bundled_item_wrap'>
<?php
if ($bundled_product->is_in_stock()) {
?>
    <div class="quantity_button">
        <div class = "<?php echo $qty_class; ?>" data-parent_id = "<?php echo $parent_id; ?>">
            <input type="button" value="-" class="minus" />
            <input 
                type = "number"
                step = "1"
                min = "<?php echo $quantity_min; ?>"
                max = "<?php echo $quantity_max; ?>"
                data-allow-backorder = "<?php echo $allowBackOrder; ?>"
                name = "quantity_<?php echo $item_data['id']; ?>"
                value = "<?php echo $quantity_min; ?>"
                title = "Qty"
                class = "input-text qty text"
                size = "<?php echo $quantity_max; ?>"
                <?php echo $disableQty; ?>
                autocomplete = "off"
            />
            <input type = "button" value = "+" class = "plus" />
        </div>
    </div>
<?php
}
?>
</div>
